summaryrefslogtreecommitdiff
path: root/.local/bin/mpvy
diff options
context:
space:
mode:
authorxyz <gky44px1999@gmail.com>2021-09-20 14:20:33 -0700
committerxyz <gky44px1999@gmail.com>2021-09-20 14:20:33 -0700
commit97da1a281a44d7784dc49a08d794a82d24d289c6 (patch)
tree13583b6ed1404f3fbc5caf8a40f9500f8c66dd9b /.local/bin/mpvy
parentd60e9164b9a3ffda29eb94f2a30e920666e23afe (diff)
mpvsel rename to mpvy, mpvy now can download only
Diffstat (limited to '.local/bin/mpvy')
-rwxr-xr-x.local/bin/mpvy46
1 files changed, 46 insertions, 0 deletions
diff --git a/.local/bin/mpvy b/.local/bin/mpvy
new file mode 100755
index 00000000..31433522
--- /dev/null
+++ b/.local/bin/mpvy
@@ -0,0 +1,46 @@
+#!/bin/sh
+# references:
+# https://www.rockyourcode.com/til-how-to-watch-youtube-videos-with-mpv-and-keyboard-shortcuts/
+# https://github.com/mpv-player/mpv/issues/7792
+
+notify ()
+{
+ notify-send "mpvsel failed"
+}
+
+fps=30
+height=$SCRHEIGHT
+url="$(xsel -ob)"
+flag=s
+
+# can improve to make s and d mutually exclusive, see curlncm, maybe not, not necessary
+# option f and h may do nothing if redownload? since same filename exist, haven't tested. yt-dlp won't download same file even without --auto-file-renameing=false. how improve?
+# how to simplify notify-send
+while getopts Aad:f:h:su: opt; do
+ case $opt in
+ # s: streaming, a: aria2c then mpv, A: aria2c
+ A|a|s) flag=$opt;;
+ d) download_dir="$OPTARG";;
+ f) fps="$OPTARG";;
+ h) height="$OPTARG";;
+ u) url="$OPTARG";;
+ \?) exit 1;;
+ esac
+done
+case $flag in
+ A) [ -z "$download_dir" ] && download_dir="$XDG_DOWNLOAD_DIR/mpvsel/";;
+ a) [ -z "$download_dir" ] && download_dir="/tmp/mpvsel/";;
+esac
+mkdir -p "$download_dir"
+vformat="[height<=?$height][fps<=?$fps][vcodec!^=?vp9][vcodec!^=?av01]"
+# usually with my vformat, video is .mp4, bestaudio is .webm, seems not a good idea to combine those, create problems when use yt-dlp to merge them, not sure about streaming
+#format="bestvideo$vformat+bestaudio/best$vformat"
+format="best$vformat"
+
+case $flag in
+ # here if use --write-sub, mpv doesn't recognize subtitles?
+ # --embed-subs is a little bit better
+ A) yt-dlp -f "$format" --embed-subs -P "$download_dir" --sponsorblock-remove all "$url" || notify;;
+ a) yt-dlp -f "$format" --embed-subs -P "$download_dir" --sponsorblock-remove all "$url" --exec "mpv --fs --speed=2" || notify;;
+ s) mpv --ytdl-format="$format" --ytdl-raw-options='write-sub=' --fs --speed=2 "$url" || notify;;
+esac